<?php
/**
 * Scand_ProductLocator extension is a extension to display specific products on Product Locator.
 * Copyright (C) 2013 Scand Ltd.
 * 
 * This file is part of Scand_ProductLocator extension.
 * 
 * Scand_ProductLocator extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scand_ProductLocator extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Scand_ProductLocator extension. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Scand
 * @package     Scand_ProductLocator
 * @copyright   Copyright (c) 2013 Scand Ltd. (http://www.scand.com)
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License (GPL 3.0)
 */

class Scand_ProductLocator_Helper_Data extends Mage_Core_Helper_Abstract
{
	public function getProductLocatorUrl() {
		return $this->_getUrl('productlocator/product');
	}
	
	public function getAddress(Scand_ProductLocator_Model_Product_Address $item) {
		$streets = array();
		$address = array();
		
		if ($item->getStreet() != "") {
			$street = $item->getStreet();
			if (isset($street[0]) && $street[0] != "")
				$streets[] = $street[0];
			if (isset($street[1]) && $street[1] != "")
				$streets[] = $street[1];
		}
		
		if ($item->getCity() != "")
			$address[] = $item->getCity();
		if ($item->getRegion() != "")
			$address[] = $item->getRegion();
		if ($item->getPostcode() != "")
			$address[] = $item->getPostcode();
		if ($item->getCountryId() != "")
			$address[] = $item->getCountryId();
		
		$ret = "";
		if(count($streets))
			$ret .= implode("<br>", $streets) . "<br />";
		$ret .= implode(", ", $address);
		
		return $ret;
	}
}
