<?php
/**
 * Scand_ProductLocator extension is a extension to display specific products on Product Locator.
 * Copyright (C) 2013 Scand Ltd.
 * 
 * This file is part of Scand_ProductLocator extension.
 * 
 * Scand_ProductLocator extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scand_ProductLocator extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Scand_ProductLocator extension. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Scand
 * @package     Scand_ProductLocator
 * @copyright   Copyright (c) 2013 Scand Ltd. (http://www.scand.com)
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License (GPL 3.0)
 */

class Scand_ProductLocator_Model_Product_Address extends Mage_Customer_Model_Address_Abstract
{
	public $addressFormPrefix = 'productlocator_address';
	
	protected function _construct() {
		$this->_init('productlocator/product_address');
	}
	
	public function appendIds($data=array()) {
		$data['address_id'] = $this->getId();
		$data['product_id'] = $this->getProductId();
		
		return $data;
	}
	
	public function loadByProduct($product_id) {
		$this->setProductId($product_id);
		$this->load($product_id, 'product_id');
		
		return $this;
	}

	public function save() {
		if ($this->isDeleted())
			return $this->delete();

		if (!$this->_hasModelChanged())
			return $this;

		$this->_getResource()->beginTransaction();

		try {
			$this->getRegion();
			$this->_getResource()->save($this);

			$this->_getResource()
				->addCommitCallback(array($this, 'afterCommitCallback'))
				->commit();
			$this->_hasDataChanges = false;
		}
		catch (Exception $e) {
			$this->_getResource()->rollBack();
			$this->_hasDataChanges = true;
			throw $e;
		}

		return $this;
	}
}
