<?php
/**
 * Scand_ProductLocator extension is a extension to display specific products on Product Locator.
 * Copyright (C) 2013 Scand Ltd.
 * 
 * This file is part of Scand_ProductLocator extension.
 * 
 * Scand_ProductLocator extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scand_ProductLocator extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Scand_ProductLocator extension. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Scand
 * @package     Scand_ProductLocator
 * @copyright   Copyright (c) 2013 Scand Ltd. (http://www.scand.com)
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License (GPL 3.0)
 */

class Scand_ProductLocator_Model_Product_Renderer_Region extends Mage_Adminhtml_Model_Customer_Renderer_Region
{
	private $_countryId = 'US'; // by default

	private function _getCountryId(Varien_Data_Form_Element_Abstract $formElement) {
		$countryElement = $formElement->getForm()->getElement('country_id');
		if ($countryElement) {
			if ($countryElement->getValue())
				$this->_countryId = $countryElement->getValue();
			else
				$countryElement->setValue($this->_countryId);
		}

		return $this;
	}

	public function render(Varien_Data_Form_Element_Abstract $formElement) {
		$this->_getCountryId($formElement);

		$regionId = intval($formElement->getForm()->getElement('region_id')->getValue());

		$htmlAttributes = $formElement->getHtmlAttributes();
		foreach ($htmlAttributes as $key => $attribute) {
			if ('type' === $attribute) {
				unset($htmlAttributes[$key]);
				break;
			}
		}

		$name = $formElement->getName();
		$htmlId = $formElement->getHtmlId();
		$idName = str_replace('region', 'region_id', $name);
		$idHtmlId = str_replace('region', 'region_id', $htmlId);
		$hasRegions = !empty(self::$_regionCollections) && count(self::$_regionCollections) > 0;

		if (!$hasRegions)
			$htmlAttributes['style'] = 'display: none;';

		$html = array('<tr>');
		$html[] = '<td class="label">'.$formElement->getLabelHtml().'</td>';
		$html[] = '<td class="value">';
		$html[] = '<select id="'.$idHtmlId.'" name="'.$idName.'" '.$formElement->serialize($htmlAttributes).'>';
		if ($hasRegions) {
			foreach (self::$_regionCollections as $region) {
				$html[] = '<option value="'.intval($region['value']).'"'.($regionId == $region['value'] ? ' selected="selected"' : '').'>'.
					$region['label'].'</option>';
			}
		}
		$html[] = "</select>";
		$html[] = '<input '.($hasRegions ? 'type="hidden"' : 'class="input-text"').' name="'.$name.'" id="'.$htmlId.'" value="'.$formElement->getValue().'"/>';
		$html[] = '</td>';
		$html[] = '</tr>';


		return implode("\n", $html);
    }
}
