<?php
/**
 * Scand_ProductLocator extension is a extension to display specific products on Product Locator.
 * Copyright (C) 2013 Scand Ltd.
 * 
 * This file is part of Scand_ProductLocator extension.
 * 
 * Scand_ProductLocator extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scand_ProductLocator extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Scand_ProductLocator extension. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Scand
 * @package     Scand_ProductLocator
 * @copyright   Copyright (c) 2013 Scand Ltd. (http://www.scand.com)
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License (GPL 3.0)
 */
 
	$installer = $this;

	$installer->startSetup();

	$this->addAttribute('customer_address', 'gmaps_lat', array(
		'type' => 'varchar',
		'input' => 'text',
		'label' => 'GMaps Latitude',
		'visible' => TRUE,
		'required' => FALSE,
	));
	
	$this->addAttribute('customer_address', 'gmaps_lng', array(
		'type' => 'varchar',
		'input' => 'text',
		'label' => 'GMaps Longitude',
		'visible' => TRUE,
		'required' => FALSE,
		'user_defined' => TRUE
	));
	
	$aAttributesIds = array();
	$aFileds = array('street', 'city', 'country_id', 'region', 'region_id', 'postcode', 'telephone', 'gmaps_lat', 'gmaps_lng');
	foreach ($aFileds as $fieldName) {
		$attributeId = Mage::getSingleton('eav/config')
			->getAttribute('customer_address', $fieldName)
			->getId();
		$aAttributesIds[] = "'product_customer_address', ".$attributeId;
	}
	$installer->run("DELETE FROM `customer_form_attribute` WHERE `form_code`='product_customer_address';");
	$installer->run("INSERT INTO `customer_form_attribute`(`form_code`,`attribute_id`) VALUES (".implode("),(", $aAttributesIds).");");
	
	$installer->run("DROP TABLE IF EXISTS `catalog_product_address`;");
	$installer->run("
		CREATE TABLE `catalog_product_address` (
		  `address_id` int(10) unsigned NOT NULL auto_increment COMMENT 'Address Id',
		  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
		  `country_id` varchar(2) default NULL COMMENT 'Country Id',
		  `region_id` int(11) default NULL COMMENT 'Region Id',
		  `region` varchar(255) default NULL COMMENT 'Region',
		  `city` varchar(255) default NULL COMMENT 'City',
		  `postcode` varchar(255) default NULL COMMENT 'Postcode',
		  `street` text COMMENT 'Street',
		  `telephone` varchar(255) default NULL COMMENT 'Telephone',
		  `gmaps_lat` decimal(10,7) signed default NULL COMMENT 'Product Locator Latitude',
		  `gmaps_lng` decimal(10,7) signed default NULL COMMENT 'Product Locator Longitude',
		  PRIMARY KEY  (`address_id`),
		  KEY `IDX_CATALOG_PRODUCT_ADDRESS_PRODUCT_ID` (`product_id`),
		  CONSTRAINT `FK_CATALOG_PRODUCT_ADDRESS_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Address';
	");
	
	$installer->endSetup();
?>